import java.io.*;
import java.util.*;
import java.text.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class Sample4 extends JFrame implements ActionListener
{
   private ThinBarGraph tbg;
   private BoldBarGraph bbg;
   private Vector<Observer> obs;
   private JList ls;
   private JScrollPane sp;
   private JButton bt;

   public static void main(String args[])
   {
      Sample4 sm = new Sample4();
   }
   public Sample4()
   {
      super("Tv");
      obs = new Vector<Observer>();
      tbg = new ThinBarGraph();
      bbg = new BoldBarGraph();
      addObserver(tbg);
      addObserver(bbg);

      ls= new JList();
      sp = new JScrollPane(ls);
      bt = new JButton("Ǎ");

      add(sp, BorderLayout.CENTER);
      add(bt, BorderLayout.SOUTH);

      bt.addActionListener(this);

      setDefaultCloseOperation(EXIT_ON_CLOSE);
      setSize(400, 200);
      setVisible(true);
      tbg.setVisible(true);
      bbg.setVisible(true);
   }
   void addObserver(Observer o)
   {
      obs.add(o);
   }
   void notifyObservers(Vector<Integer> d)
   {
      Iterator<Observer> it = obs.iterator();
      while(it.hasNext()){
         Observer o = it.next();
         o.update(d);
      }
   }
   public void actionPerformed(ActionEvent e)
   {
      JFileChooser fc = new JFileChooser();
      try{
         int res = fc.showOpenDialog(this);
         if(res == JFileChooser.APPROVE_OPTION){       
            File fl = fc.getSelectedFile();
            BufferedReader br = new BufferedReader(new FileReader(fl));

            Vector<Integer> data = new Vector<Integer>();
            String str;
            while((str = br.readLine()) != null){
               data.add(Integer.parseInt(str));

            }
            br.close();
            ls.setListData(data);
            notifyObservers(data);
         }
      }catch(Exception ex){}
   }
}
